<?php
if ( !defined( 'AREA' ) ) {
    die( 'Direct Access Denied' );
}

if ( !defined( 'PAYMENT_NOTIFICATION' ) ) {			
	$cart_currency = strtolower(CART_SECONDARY_CURRENCY);				
	//$cart_currency = 'SAR';
	$total = fn_format_price_by_currency($order_info['total']);		
	$total = number_format($total, 2, '.', '');
	list($firstname, $lastname) = explode(" ", $order_info['payment_info']['cardholder_name']);
	if (empty($lastname)) {
		$lastname = $order_info['b_lastname'];
		$firstname = $order_info['b_firstname'];		
	}
	$trans_no = $order_id.'_'.time();
	$expyear = $order_info['payment_info']['expiry_year'];
	if (strlen($expyear) < 4) $expyear = '20'.$expyear;
	$data = array();
	$data['action'] = 'SALE';
	$data['client_key'] = $processor_data['processor_params']['merchant_key'];
	$data['order_id'] = $trans_no;
	$data['order_amount'] =$total;
	$data['order_currency'] = strtoupper($cart_currency);
	$data['order_description'] = 'Order No:'.$order_id;
	$data['card_number'] = $order_info['payment_info']['card_number'];
	$data['card_exp_month'] = $order_info['payment_info']['expiry_month'];
	$data['card_exp_year'] = $expyear;
	$data['card_cvv2'] = $order_info['payment_info']['cvv2'];
	$data['payer_first_name'] = $firstname;
	$data['payer_last_name'] = $lastname;
	$data['payer_address'] = $order_info['b_address'];
	$data['payer_country'] = $order_info['b_country'];
	$data['payer_state'] = $order_info['b_state'];
	$data['payer_city'] = $order_info['b_city'];	
	$data['payer_zip'] = $order_info['b_zipcode'];
	$data['payer_email'] = $order_info['email'];
	$data['payer_phone'] = $order_info['phone'];
	$data['payer_ip'] = $_SERVER['REMOTE_ADDR'];
	$data['term_url_3ds'] = fn_url( "payment_notification.return?payment=expresspays2s&act=ret&csorder_id=$order_id" );
	$merchant_password = $processor_data['processor_params']['merchant_password'];
	$hash = md5(strtoupper(strrev($data['payer_email']).$merchant_password.strrev(substr($data['card_number'],0,6).substr($data['card_number'],-4))));
	$data['hash'] = $hash;
	

	$url = 'https://api.expresspay.sa/post';            			
	
	
	$result = fn_expresspays2s_api($url,$data);
	fn_expresspays2s_log('payment', $result);
	$responsear = json_decode($result, true) ;	
	if ($responsear['status'] == 'REDIRECT'){			
		$redirect_url = $responsear['redirect_url'];
		$result = fn_expresspays2s_api($redirect_url,$responsear['redirect_params']);		
		echo $result;
		exit;		
	}
	else {
		$pp_response['order_status'] = 'D';
		$pp_response["reason_text"] = $responsear['error_message'];
		echo $result;
		
		exit;
	}
exit;	
	
} else if ( defined( 'PAYMENT_NOTIFICATION' ) ) {
	$act = $_GET['act'];
	if ($act == 'callback'){
		$cbres = $_REQUEST;		
		fn_expresspays2s_log('callback', json_encode($cbres));
		
		list($order_id) = explode('_', $cbres['order_id']);
		
		$status = $cbres['status'];		
		if ($status == 'SETTLED'){	
			$order_info = fn_get_order_info($order_id);	
			$processor_data = fn_get_processor_data($order_info['payment_id']);
			$merchant_password = $processor_data['processor_params']['merchant_password'];

			$vhash = md5(strtoupper(strrev($order_info['email']).$merchant_password.$cbres['trans_id'].strrev(substr($cbres['card'],0,6).substr($cbres['card'],-4))));
			
			if ($vhash != $cbres['hash']){
				$pp_response['order_status']   = 'F';
				$pp_response["reason_text"] = 'Hash is invalid ';				
				fn_finish_payment($order_id, $pp_response);			
				fn_expresspays2s_log('verify hash', $vhash);
				fn_expresspays2s_log('hash', $cbres['hash']);				
				exit;

			}

			


			$pp_response['order_status']   = 'P';		
			$pp_response['reason_text']    = __('transaction_approved');
			$pp_response['transaction_id'] = $cbres['trans_id'];
			fn_change_order_status($order_id, 'P', '');	
			fn_update_order_payment_info($order_id, $pp_response);			
            fn_finish_payment($order_id, $pp_response, true);
		}
		else if ($status == 'DECLINED'){			
			$pp_response['order_status']   = 'F';
			$pp_response["reason_text"] = __('transaction_declined').'  '.$cbres['decline_reason'];								
			fn_expresspays2s_log('decline_reason', $cbres['decline_reason']);
			fn_finish_payment($order_id, $pp_response);			
		}
		   				
	}
	else {
		sleep(5);
		$order_id = $_GET['csorder_id'];
		fn_order_placement_routines('route', $order_id);	
	}
	
	
	exit;		
	
}

function fn_expresspays2s_api($url, $data){
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_POST , 1 );
	curl_setopt($ch, CURLOPT_POSTFIELDS , $data );
	curl_setopt($ch, CURLOPT_URL , $url );			
	curl_setopt($ch, CURLINFO_HEADER_OUT , TRUE );
	curl_setopt($ch, CURLOPT_RETURNTRANSFER , 1 );
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER , FALSE);            
	$result = curl_exec( $ch );            
	curl_close( $ch ); 	
	return $result;
}
function fn_expresspays2s_log($logtype,$message){
	$message = date("j.n.Y").' - '.$logtype.' - '.$message.PHP_EOL;
	file_put_contents(dirname(__FILE__).'/expresspays2s_api.log', $message, FILE_APPEND);
}

